<?php
/**
 * 画像ユニット高機能版.
 *
 * @package units
 *
 * @copyright 2008-2016 Shift Tech Inc. All Rights Reserved.
 * @author    シフトテック株式会社<http://www.shift-tech.jp>
 *
 * @version   1.7.x
 */
require_once LIB_PATH.'/common/unitCommon.php';
require_once LIB_PATH.'/common/labelDB.php';
/**
 * 動画ユニット高機能版.
 */
class extSearch extends unitCommon
{
    //------ ユニット毎に必ず設定しなくてはならない変数 -------//
    /** @var string $_table 公開用テーブル名 unit_multiple_data */
    public $_table = 'unit_multiple_data';       //公開用テーブル名
    /** @var string $_tmptable 下書き用テーブル名 unit_multiple_data_tmp */
    public $_tmptable = 'unit_multiple_data_tmp'; //下書き用テーブル名
    /** @var string $_unit_dir ユニットディレクトリ名 */
    public $_unit_dir = 'extSearch';
    /** @var array $columns テーブル列設定 */
    public $columns = array(
        array('column' => 'pageu_code', 'conv' => 'n', 'tags' => false),  //ユニット個別ID
        array('column' => 'pageu_unit_code', 'conv' => 'n', 'tags' => false),  //ユニット個別ID
        array('column' => 'pageu_unit_name', 'conv' => 'Kva', 'tags' => false),  //ユニット個別ID
        array('column' => 'mlt_data1', 'conv' => 'Kva', 'tags' => false),  //データ1
        array('column' => 'mlt_data2', 'conv' => 'Kva', 'tags' => true),  //データ2
        array('column' => 'mlt_data3', 'conv' => 'Kva', 'tags' => false),  //データ3
        array('column' => 'mlt_data4', 'conv' => 'Kva', 'tags' => false),  //データ4
        array('column' => 'mlt_data5', 'conv' => 'Kva', 'tags' => false),  //データ5
        array('column' => 'mlt_data6', 'conv' => 'Kva', 'tags' => false),  //データ6
        array('column' => 'mlt_data7', 'conv' => 'Kva', 'tags' => false),  //データ7
        array('column' => 'mlt_data8', 'conv' => 'Kva', 'tags' => false),  //データ8
        array('column' => 'mlt_data9', 'conv' => 'Kva', 'tags' => false),  //データ9
        array('column' => 'mlt_data10', 'conv' => 'Kva', 'tags' => false),  //データ10
        array('column' => 'mlt_data11', 'conv' => 'Kva', 'tags' => false),  //データ11
        array('column' => 'mlt_data12', 'conv' => 'Kva', 'tags' => false),  //データ12
        array('column' => 'mlt_data13', 'conv' => 'Kva', 'tags' => false),  //データ13
        array('column' => 'mlt_data14', 'conv' => 'Kva', 'tags' => false),  //データ14
        array('column' => 'mlt_data15', 'conv' => 'Kva', 'tags' => false),  //データ15
        array('column' => 'mlt_data16', 'conv' => 'Kva', 'tags' => false),  //データ16
        array('column' => 'mlt_data17', 'conv' => 'Kva', 'tags' => false),  //データ17
        array('column' => 'mlt_data18', 'conv' => 'Kva', 'tags' => false),  //データ18
        array('column' => 'mlt_data19', 'conv' => 'Kva', 'tags' => false),  //データ19
        array('column' => 'mlt_data20', 'conv' => 'Kva', 'tags' => false),  //データ20
        array('column' => 'mlt_data21', 'conv' => 'Kva', 'tags' => false),  //データ21
        array('column' => 'mlt_data22', 'conv' => 'Kva', 'tags' => false),  //データ22
        array('column' => 'mlt_data23', 'conv' => 'Kva', 'tags' => false),  //データ23
        array('column' => 'mlt_data24', 'conv' => 'Kva', 'tags' => false),  //データ24
        array('column' => 'mlt_data25', 'conv' => 'Kva', 'tags' => false),  //データ25
        array('column' => 'mlt_data26', 'conv' => 'Kva', 'tags' => false),  //データ26
        array('column' => 'mlt_data27', 'conv' => 'Kva', 'tags' => false),  //データ27
        array('column' => 'mlt_data28', 'conv' => 'Kva', 'tags' => false),  //データ28
        array('column' => 'mlt_data29', 'conv' => 'Kva', 'tags' => false),  //データ29
        array('column' => 'mlt_data30', 'conv' => 'Kva', 'tags' => false),  //データ30
        array('column' => 'mlt_data31', 'conv' => 'Kva', 'tags' => false),  //データ31
        array('column' => 'mlt_data32', 'conv' => 'Kva', 'tags' => false),  //データ32
        array('column' => 'mlt_data33', 'conv' => 'Kva', 'tags' => false),  //データ33
        array('column' => 'mlt_data34', 'conv' => 'Kva', 'tags' => false),  //データ34
        array('column' => 'mlt_data35', 'conv' => 'Kva', 'tags' => false),  //データ35
        array('column' => 'mlt_data36', 'conv' => 'Kva', 'tags' => false),  //データ36
        array('column' => 'mlt_data37', 'conv' => 'Kva', 'tags' => false),  //データ37
        array('column' => 'mlt_data38', 'conv' => 'Kva', 'tags' => false),  //データ38
        array('column' => 'mlt_data39', 'conv' => 'Kva', 'tags' => false),  //データ39
        array('column' => 'mlt_data40', 'conv' => 'Kva', 'tags' => false),  //データ40
        array('column' => 'mlt_data41', 'conv' => 'Kva', 'tags' => false),  //データ41
        array('column' => 'mlt_data42', 'conv' => 'Kva', 'tags' => false),  //データ42
        array('column' => 'mlt_data43', 'conv' => 'Kva', 'tags' => false),  //データ43
        array('column' => 'mlt_data44', 'conv' => 'Kva', 'tags' => false),  //データ44
        array('column' => 'mlt_data45', 'conv' => 'Kva', 'tags' => false),  //データ45
        array('column' => 'mlt_data46', 'conv' => 'Kva', 'tags' => false),  //データ46
        array('column' => 'mlt_data47', 'conv' => 'Kva', 'tags' => false),  //データ47
        array('column' => 'mlt_data48', 'conv' => 'Kva', 'tags' => false),  //データ48
        array('column' => 'mlt_data49', 'conv' => 'Kva', 'tags' => false),  //データ49
        array('column' => 'mlt_data50', 'conv' => 'Kva', 'tags' => false),  //データ50
        array('column' => 'bg_color', 'conv' => 'n', 'tags' => false),    //背景色
        array('column' => 'bdr_type', 'conv' => 'n', 'tags' => false),    //枠線
        array('column' => 'btm_padding', 'conv' => 'n', 'tags' => false),  //下方スペース
        array('column' => 'bg_color_sp', 'conv' => 'n', 'tags' => false),    //背景色
        array('column' => 'bdr_type_sp', 'conv' => 'n', 'tags' => false),    //枠線
        array('column' => 'btm_padding_sp', 'conv' => 'n', 'tags' => false),  //下方スペース
        array('column' => 'use_pc_flg', 'conv' => 'n', 'tags' => false),  //PCフラグ
        array('column' => 'use_sp_flg', 'conv' => 'n', 'tags' => false),  //スマホフラグ
        array('column' => 'extra_class', 'conv' => 'as', 'tags' => false),  //追加クラス
        array('column' => 'option_extend', 'conv' => 'n', 'tags' => false),  //デザインオプションの継承
    );
    /** @var array $column_link テーブル列とフォーム名のマッピング用配列 */
    public $column_link = array(
        1 => 'anchor_text',
        2 => 'unit_sync',
        3 => 'url',
        4 => 'labelg_code',
        5 => 'field_name',
        6 => 'field_w',
        7 => 'align',
        8 => 'btn_name',
        9 => 'btn_value',
        10 => 'sort_use',
        11 => 'sort_name',
        12 => 'sort_default',
        13 => 'label_view',
        14 => 'field_w_sp',
        15 => 'btn_value_sp',
        16 => 'align_sp',
        17 => 'sort_use_sp',
        18 => 'label_view_sp',
        19 => 'label_default_checked',
        20 => 'placeholder',
        21 => 'placeholder_sp',
    );
    //▼変数宣言///////////////////
    /** @var array $_data データ */
    public $_data;
    //▲変数宣言///////////////////

    /**
     * コンストラクタ
     */
    public function __construct()
    {
        unitCommon::__construct();
    }
    /**
     * 出力データセット処理.
     *
     * @return null|array
     */
    public function setDisplayData()
    {
        $this->_data = $this->getDetail();
        $props = $this->getProp($this->_pageu_code);
        $unitCss = array();

        //▼データ操作  ////////
        if ($this->_data != null) {
            $this->_data['class'] = $this;
            if ($this->checkSP()) {
                //スマホ時
                if($this->_data['unit_sync'] == 1) {
                    //PCを継承時はPCパラメータで上書きしておく
                    $props[1] = $props[0];
                }
                if(is_array($props) && isset($props[1])) {
                    $this->_data = array_merge($this->_data, $props[1]);
                }

                if($this->_data['unit_sync'] != 1) {
                    foreach($this->_data as $k=>$v) {
                        if(preg_match("/(.*)_sp$/", $k, $m)) {
                            $this->_data[$m[1]] = $this->_data[$m[0]];
                        }
                    }
                }
            } else {
                if(is_array($props) && isset($props[0])) {
                    $this->_data = array_merge($this->_data, $props[0]);
                }
            }

            $labelDB = new labelDB();
            if(isset($this->_data['label_view']) && 0 < strlen($this->_data['label_view'])) {
                $labels = $labelDB->getList('label_code IN('.preg_replace("/(\d)+/", "?", $this->_data['label_view']).')', explode(",",$this->_data['label_view']), 0, true);
                $this->_data['LABELS'] = $labels;
            }

            //共通プロパティ（余白とか）
            $unitStyle = $this->createUnitStyle($this->_data);
            if(0 < count($unitStyle)) {
                $this->_data['unitStyle'] = implode(' ', $unitStyle);
            }

            if(is_numeric($this->_data['field_w'])) {
                $this->_data['field_w'] .= 'px';
            }

            if(!isset($this->_data['field_name'])) {
                $this->_data['field_name'] = "search";
            }
            if(!isset($this->_data['sort_name'])) {
                $this->_data['sort_name'] = "searchOrder";
            }
            if(!isset($this->_data['btn_name'])) {
                $this->_data['btn_name'] = "BTNsearch";
            }

            //初期
            // if(!isset($_GET[$this->_data['field_name']]) && !isset($_GET["extSearchLabel"]) && !isset($_GET[$this->_data['sort_name']])) {
            if(!isset($_GET["extSearchLabel"]) && !isset($_GET[$this->_data['sort_name']])) {
                // $this->_data['label_value']
                $label_value = array();
                if(is_array($labels)) {
                    foreach($labels as $v) {
                        $label_value[$v['label_code']] = $this->_data['label_default_checked'];
                    }
                }
                $this->_data['label_value'] = $label_value;
            }

            //リクエスト
            if(isset($_GET[$this->_data['field_name']])) {
                $this->_data['field_value'] = $_GET[$this->_data['field_name']];
            }
            if(isset($_GET[$this->_data['sort_name']])) {
                $this->_data['sort_value'] = $_GET[$this->_data['sort_name']];
            } else {
                $this->_data['sort_value'] = $this->_data['sort_default'];
            }
            if(isset($_GET["extSearchLabel"])) {
                $this->_data['label_value'] = $_GET["extSearchLabel"];
            }
            $this->_data['isSP'] = Model::checkSP();
            $this->_data['prev'] = "";
            if($this->_prev) {
                $this->_data['prev'] = "&prev=1";
            }
        }

        //▲データ操作  ////////
        $this->_view->assign('pageu_code', $this->_pageu_code);
        $this->_view->assign('data', $this->_data);
        $this->_view->assign('ua', $this->_ua);
        $this->addLoadCss(BINGOTOPURL.'/css/components/incremental.css');

        return $this->_data;
    }

    /**
     * DBより保存データ取得.
     *
     * @return null|array
     */
    public function getDetail()
    {
        $sql = 'SELECT * FROM '.$this->getTbl().' WHERE pageu_code = ?';
        if (isset($this->_pageu_code) && is_numeric($this->_pageu_code)) {
            $result = $this->db->prepare($sql, $this->_pageu_code);
            $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
            $data = $this->replaceMultipleData($row, $this->column_link);
        }

        return $data;
    }
    /**
     * フォーム初期値をセット.
     */
    public function setDefault()
    {
        $this->_data = $this->getDetail();
        $this->_data = $this->getProperty4device($this->_data);

        if (!$this->_data) {
            $this->_data['url'] = '';
            $this->_data['field_name'] = 'extSearch';
            $this->_data['field_w'] = '200';
            $this->_data['btn_name'] = 'extSearchBtn';
            $this->_data['btn_value'] = '検索';
            $this->_data['sort_name'] = 'extSearchOrder';
            $this->_data['sort_use'] = 0;
            $this->_data['sort_use_sp'] = 0;
            $this->_data['sort_default'] = 0;
            $this->_data['unit_sync'] = 1;
            $this->_data['align'] = 'left';
            $this->_data['align_sp'] = 'left';
            $this->_data['label_default_checked'] = 1;
        } else {
            $labelg = explode(',', $this->_data['labelg_code']);
            $this->_data['labelg_code'] = array_combine($labelg, array_pad(array(), count($labelg), 1));

            $label = explode(',', $this->_data['label_view']);
            $this->_data['label_view'] = array_combine($label, array_pad(array(), count($label), 1));

            $label_sp = explode(',', $this->_data['label_view_sp']);
            $this->_data['label_view_sp'] = array_combine($label_sp, array_pad(array(), count($label_sp), 1));
        }

        $this->_form->setDefaults($this->_data);
    }
    /**
     * フォームエレメントの作成.
     */
    public function setElements()
    {
        $this->_view->assign('data', $this->_data);
        $this->_form->addElement('hidden', 'pageu_code', $this->_pageu_code, array('id' => 'pageu_code')); //ページコード

        $this->_form->addElement('text', 'url', null, array('id'=>'url', 'placeholder'=>'ラベル検索対応の連載記事ユニットが配置してあるページのURLを設定してください'));
        $this->_form->addElement('text', 'field_name', null, array('id'=>'field_name'));
        $this->_form->addElement('text', 'field_w', null, array('id'=>'field_w', 'class'=>'num numL'));
        $this->_form->addElement('text', 'placeholder', null, array('id'=>'placeholder'));
        $this->_form->addElement('text', 'placeholder_sp', null, array('id'=>'placeholder_sp'));
        $this->_form->addElement('text', 'btn_name', null, array('id'=>'btn_name'));
        $this->_form->addElement('text', 'btn_value', null, array('id'=>'btn_value'));
        $this->_form->addElement('text', 'field_w_sp', null, array('id'=>'field_w_sp', 'class'=>'num numL'));
        $this->_form->addElement('text', 'btn_value_sp', null, array('id'=>'btn_value_sp'));

        //カテゴリ
        $labelDB = new labelDB();
        $groups = $labelDB->getGroupList(null, null, 0, true);
        // array_shift($groups);
        $ar = array();
        foreach($groups as $k => $v) {
            $ar[] = $this->_form->createElement('checkbox', $v['labelg_code'], null, $v['labelg_name'], array('labelClass' => 'checkBtn'));
        }
        $this->_form->addGroup($ar, "labelg_code", null, "");

        //ラベル
        $ar = array();
        $labels = $labelDB->getList(null, null, 0, true, true);

        foreach($labels as $k => $v) {
            if(empty($v['labelg_code_string'])) {
                $v['labelg_code_string'] = 0;
            }
            $ar[] = $this->_form->createElement('checkbox', $v['label_code'], null, $v['label_name'], array('labelClass' => 'checkBtn', 'data-group'=>$v['labelg_code_string']));
        }
        $this->_form->addGroup($ar, "label_view", null, "");

        $ar = array();
        foreach($labels as $k => $v) {
            $ar[] = $this->_form->createElement('checkbox', $v['label_code'], null, $v['label_name'], array('labelClass' => 'checkBtn', 'data-groupsp'=>$v['labelg_code_string']));
        }
        $this->_form->addGroup($ar, "label_view_sp", null, "");
        $this->_form->addElement('advcheckbox', 'label_default_checked', null, 'アクティブ', array('id'=>'label_default_checked'), array(0,1));

        // $this->_form->addElement('checkbox', 'label_view', null, '表示する', array('id'=>'label_view'), array(0,1));
        // $this->_form->addElement('checkbox', 'label_view_sp', null, '表示する', array('id'=>'label_view_sp'), array(0,1));

        //整列
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('左'), 'left', array('labelClass'=>'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, _gettext('中央'), 'center', array('labelClass'=>'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, _gettext('右'), 'right', array('labelClass'=>'radioBtn alignR')),
        ), 'align', '', '');
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('左'), 'left', array('labelClass'=>'radioBtn alignL')),
            $this->_form->createElement('radio', null, null, _gettext('中央'), 'center', array('labelClass'=>'radioBtn alignC')),
            $this->_form->createElement('radio', null, null, _gettext('右'), 'right', array('labelClass'=>'radioBtn alignR')),
        ), 'align_sp', '', '');

        $this->_form->addElement('advcheckbox', 'sort_use', null, '表示する', array(), array(0, 1));
        $this->_form->addElement('advcheckbox', 'sort_use_sp', null, '表示する', array(), array(0, 1));
        $this->_form->addElement('text', 'sort_name', null, array('id'=>'sort_name'));
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('新しい順'), 0, array('labelClass'=>'radioBtn')),
            $this->_form->createElement('radio', null, null, _gettext('古い順'), 1, array('labelClass'=>'radioBtn')),
        ), 'sort_default', '', '');

        //設定継承
        $this->_form->addGroup(array(
            $this->_form->createElement('radio', null, null, _gettext('しない'), 1, array('labelClass'=>'radioBtn')),
            $this->_form->createElement('radio', null, null, _gettext('する'), 0, array('labelClass'=>'radioBtn')),
        ), 'unit_sync', '', '');

        $this->_view->assign('groups',$groups);
    }
    /**
     * フォーム入力エラーチェックの設定.
     */
    public function setRules()
    {
        $this->_form->applyFilter('__ALL__', 'trim');
        $this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues, $this->columns); //ルールに従った値変換、タグの除去
        $this->_form->setJsWarnings('下記の項目が不正です。', '');
        $this->_form->addRule('pageu_code', '・「ユニットコード」が不明です。コンテンツ管理よりやり直してください', 'required', null, $this->erchk);

        $this->_form->registerRule('check_css_property2', 'regex', "/^\d+$|\d+(px|%)$|^auto$/");

    }
    /**
     * データ下書き保存処理.
     *
     * @param array $post 保存データ
     *
     * @return null|string エラー時=string
     */
    public function doSave($post)
    {
        if (!is_numeric($post['pageu_code'])) {
            return '・データの保存に失敗しました';
        }

        $unit_sync = $post['unit_sync'];

        if(is_array($post['labelg_code'])) {
            $post['labelg_code'] = implode(',', array_keys($post['labelg_code']));
        }
        if(is_array($post['label_view'])) {
            $post['label_view'] = implode(',', array_keys($post['label_view']));
        }
        if(is_array($post['label_view_sp'])) {
            $post['label_view_sp'] = implode(',', array_keys($post['label_view_sp']));
        }

        $post = $this->replaceMultipleData($post, $this->column_link, 'mlt_data', true);

        //既存データがあるか確認
        $old_data = $this->getDetail();
        $record = null;
        foreach ($this->columns as $val) {
            if ($post[$val['column']] != null) {
                $record[$val['column']] = $post[$val['column']];
            } else {
                $record[$val['column']] = null;
            }
        }

        if($unit_sync == 1) {
            $record['bg_color_sp'] = $record['bg_color'];
            $record['bdr_type_sp'] = $record['bdr_type'];
            $record['btm_padding_sp'] = $record['btm_padding'];

            foreach($this->column_link as $k=>$v) {
                if(preg_match("/(.*)_sp$/", $v, $m)){
                    $record['mlt_data'.array_search($v, $this->column_link)] = $record['mlt_data'.array_search($m[1], $this->column_link)];
                }
            }
        }

        $record['pageu_unit_code'] = $this->_unit_data['unit_code'];
        $record['pageu_unit_name'] = $this->_unit_data['unit_name'];
        $this->db->query('BEGIN');
        //保存処理開始
        //基本データ
        if (is_array($old_data) && count($old_data) > 0) {
            //更新
            if (!$this->db->update($this->getTbl(), $record, 'pageu_code='.$record['pageu_code'])) {
                $this->db->query('ROLLBACK');

                return '・データの保存に失敗しました';
            }
        } else { //新規
            if (!$this->db->insert($this->getTbl(), $record)) {
                $this->db->query('ROLLBACK');

                return '・データの保存に失敗しました';
            }
        }
        $this->db->query('COMMIT');

        return;
    }
}
